#define S_FUNCTION_NAME  ball_global2local
#define S_FUNCTION_LEVEL 2
#include "simstruc.h"
#include "math.h"

/*====================*
 * S-function methods *
 *====================*/

static void mdlInitializeSizes(SimStruct *S)
{
    ssSetNumSFcnParams(S, 0);
    if (ssGetNumSFcnParams(S) != ssGetSFcnParamsCount(S)) {
        return;
    }

    ssSetNumContStates(S, 0);
    ssSetNumDiscStates(S, 0);

    if (!ssSetNumInputPorts(S, 2)) return;
    
    ssSetInputPortWidth(S, 0, 3);
    ssSetInputPortDataType(S, 0, SS_DOUBLE);
    ssSetInputPortDirectFeedThrough(S, 0, 1);
    ssSetInputPortRequiredContiguous(S, 0, 1);
    
    ssSetInputPortWidth(S, 1, 3);
    ssSetInputPortDataType(S, 1, SS_DOUBLE);
    ssSetInputPortDirectFeedThrough(S, 1, 1);
    ssSetInputPortRequiredContiguous(S, 1, 1);
    

    if (!ssSetNumOutputPorts(S, 1)) return;
    /*Local Opponent */

    ssSetOutputPortWidth(S, 0, 3);
    ssSetOutputPortDataType(S, 0, SS_DOUBLE);
    
    ssSetNumSampleTimes(S, 1);
    ssSetNumRWork(S, 0);
    ssSetNumIWork(S, 0);
    ssSetNumPWork(S, 0);
    ssSetNumModes(S, 0);
    ssSetNumNonsampledZCs(S, 0);

    ssSetOptions(S, 0);
}

static void mdlInitializeSampleTimes(SimStruct *S)
{
    ssSetSampleTime(S, 0, INHERITED_SAMPLE_TIME);
    ssSetOffsetTime(S, 0, FIXED_IN_MINOR_STEP_OFFSET);

}

static void mdlOutputs(SimStruct *S, int_T tid)
{
    const real_T* ballglobal = (const real_T*) ssGetInputPortSignal(S,0);
    const real_T* pose = (const real_T*) ssGetInputPortSignal(S,1);
    real_T* balllocal = ssGetOutputPortSignal(S,0);
     
    /*ball*/
    balllocal[0] = cos(pose[2])*(ballglobal[0]-pose[0]) + sin(pose[2])*(ballglobal[1]-pose[1]);
    balllocal[1] = -sin(pose[2])*(ballglobal[0]-pose[0]) + cos(pose[2])*(ballglobal[1]-pose[1]);
    balllocal[2] = ballglobal[2];
}

static void mdlTerminate(SimStruct *S)
{
}

#ifdef  MATLAB_MEX_FILE    /* Is this file being compiled as a MEX-file? */
#include "simulink.c"      /* MEX-file interface mechanism */
#else
#include "cg_sfun.h"       /* Code generation registration function */
#endif
