#ifndef CONSTANT_PARAMETERS
#define CONSTANT_PARAMETERS

#include "global_par.h"

/*parameters which are required to be constant*/
#define NBALLS 50 /*amount of candidate balls*/
#define SIZEX 640
#define SIZEY 480
#define NPIXELS (SIZEX*SIZEY)

/*constants
 * NOTE: in vision_turtle/path_planner also two constants related to field size */
#define SELFRADIUS ROBOTRADIUS
#define MIRRORHEIGHT 0.72

/*parameters to determine the estimated ballsize in findball.c*/
#define BALLSIZE(m) ((-0.05970998385859*m+1.17201657991133)*m-8.39243848686579)*m+25.68131868131875;

#define MAXLINEPOINTS 400
#define NANGLES 200 

/*findpose.c*/
#define MINLINEPOINTS 28 /*minimum amount of whitepoints that should be detected*/
#define NP 3 /*amount of optimization parameters*/
#define MP (NP+1) /*amount of simplex vertices*/
#define FTOL 1.0e-6
#define TINY 1.0e-10
#define INITSIMPLEXSIZE 0.1 /*initial simplex size*/

/*compasscheck.c*/
#define COMPASSANGLETHRESHOLD 45

#endif
