#define S_FUNCTION_NAME  labellerconvhull_invgreen
#define S_FUNCTION_LEVEL 2
#include "simstruc.h"
#include "../../Global_par/constants.h"

#define DS 1
static uint8_T bound[256>>DS][256>>DS][256>>DS];

static void mdlInitializeSizes(SimStruct *S)
{
    DECL_AND_INIT_DIMSINFO(inputDimsInfo);
    DECL_AND_INIT_DIMSINFO(outputDimsInfo);

    FILE *fid;

    /*PARAMETERS*/
    ssSetNumSFcnParams(S, 0);
    if (ssGetNumSFcnParams(S) != ssGetSFcnParamsCount(S)) {
        return; /* Parameter mismatch will be reported by Simulink */
    }
     fid=fopen("green.dat","rb");
    if (fid!=NULL)
    {
        fread(bound,1,(256>>DS)*(256>>DS)*(256>>DS),fid);
        fclose(fid);
    }
    bound[0][0][0] = 255; /*masked data can't be a ball*/
    
    /*INPUT PORTS*/
    if (!ssSetNumInputPorts(S, 3)) return;
    
    inputDimsInfo.width = SIZEX;
    ssSetInputPortDimensionInfo(S, 0, &inputDimsInfo);
    ssSetInputPortMatrixDimensions(  S ,0, SIZEX, SIZEY);
    ssSetInputPortDataType(S, 0, SS_UINT8);
    ssSetInputPortDirectFeedThrough(S, 0, 1);
    ssSetInputPortRequiredContiguous(S, 0, 1);
    
    inputDimsInfo.width = SIZEX;
    ssSetInputPortDimensionInfo(S, 1, &inputDimsInfo);
    ssSetInputPortMatrixDimensions(  S ,1, SIZEX, SIZEY);
    ssSetInputPortDataType(S, 1, SS_UINT8);
    ssSetInputPortDirectFeedThrough(S, 1, 1);
    ssSetInputPortRequiredContiguous(S, 1, 1);
    
    inputDimsInfo.width = SIZEX;
    ssSetInputPortDimensionInfo(S, 2, &inputDimsInfo);
    ssSetInputPortMatrixDimensions(  S ,2, SIZEX, SIZEY);
    ssSetInputPortDataType(S, 2, SS_UINT8);
    ssSetInputPortDirectFeedThrough(S, 2, 1);
    ssSetInputPortRequiredContiguous(S, 2, 1);
     
    /*OUTPUT PORTS*/
    if (!ssSetNumOutputPorts(S, 1)) return;
    
    outputDimsInfo.width = SIZEX;
    ssSetOutputPortDimensionInfo(S, 0, &outputDimsInfo);
    ssSetOutputPortMatrixDimensions( S ,0, SIZEX, SIZEY);
    ssSetOutputPortDataType(S, 0, SS_UINT8);
}

static void mdlInitializeSampleTimes(SimStruct *S)
{
    ssSetSampleTime(S, 0, CONTINUOUS_SAMPLE_TIME);
    ssSetOffsetTime(S, 0, 0.0);
}

#define MDL_START  /* Change to #undef to remove function */
#if defined(MDL_START)
static void mdlStart(SimStruct *S)
{


}
#endif /*  MDL_START */

static void mdlOutputs(SimStruct *S, int_T tid)
{
    const uint8_T   *y  = (const uint8_T*) ssGetInputPortSignal(S,0);
    const uint8_T   *u  = (const uint8_T*) ssGetInputPortSignal(S,1);
    const uint8_T   *v  = (const uint8_T*) ssGetInputPortSignal(S,2);
    uint8_T        *z  = (uint8_T *)ssGetOutputPortRealSignal(S,0);

    int_T i;

    --z;
    --y;
    --u;
    --v;
    for (i=0;i<NPIXELS;++i)
        *(++z) = !bound[(*(++v))>>DS][(*(++u))>>DS][(*(++y))>>DS];
}

#undef MDL_INITIALIZE_CONDITIONS   /* Change to #undef to remove function */
#undef MDL_UPDATE  /* Change to #undef to remove function */
#undef MDL_DERIVATIVES  /* Change to #undef to remove function */

static void mdlTerminate(SimStruct *S)
{
}

#ifdef  MATLAB_MEX_FILE    /* Is this file being compiled as a MEX-file? */
#include "simulink.c"      /* MEX-file interface mechanism */
#else
#include "cg_sfun.h"       /* Code generation registration function */
#endif
