#define S_FUNCTION_NAME staticmask
#define S_FUNCTION_LEVEL 2

#include "simstruc.h"
#include "math.h"
#include "../../Global_par/constants.h"

static uint8_T mask[NPIXELS];
static uint8_T *pmask = mask;

static void mdlInitializeSizes(SimStruct *S)
{
    DECL_AND_INIT_DIMSINFO(outputDimsInfo);

    FILE *fid;

    /*PARAMETERS*/
    ssSetNumSFcnParams(S, 0);
    if (ssGetNumSFcnParams(S) != ssGetSFcnParamsCount(S)) {
        return; /* Parameter mismatch will be reported by Simulink */
    }
    
    fid=fopen("mask.dat","rb");
    if (fid!=NULL)
    {
        fread(mask,1,NPIXELS,fid);
        fclose(fid);
    }
    
    /*INPUT PORTS*/
    if (!ssSetNumInputPorts(S, 0)) return;
   
    /*OUTPUT PORTS*/
    if (!ssSetNumOutputPorts(S, 1)) return;
    
    outputDimsInfo.width = SIZEX;
    ssSetOutputPortDimensionInfo(S, 0, &outputDimsInfo);
    ssSetOutputPortMatrixDimensions( S ,0, SIZEX, SIZEY);
    ssSetOutputPortDataType(S, 0, SS_UINT8);
}

static void mdlInitializeSampleTimes(SimStruct *S)
{
    ssSetSampleTime(S, 0, INHERITED_SAMPLE_TIME);
    ssSetOffsetTime(S, 0, 0.0);
}

static void mdlOutputs(SimStruct *S, int_T tid)
{
    /*outputs*/
    uint8_T        *input  = (uint8_T *)ssGetInputPortRealSignal(S,0);
    uint8_T        *output  = (uint8_T *)ssGetOutputPortRealSignal(S,0);
    
    int i;
    pmask = mask;
    for (i=0;i<NPIXELS;++i) *output++ = *pmask++;
}

# define MDL_SET_OUTPUT_PORT_DIMENSION_INFO
static void mdlSetOutputPortDimensionInfo(SimStruct        *S,
int_T            port,
const DimsInfo_T *dimsInfo)
{
    if(!ssSetOutputPortDimensionInfo(S, port, dimsInfo)) return;
}

static void mdlTerminate(SimStruct *S)
{
}

#ifdef  MATLAB_MEX_FILE    /* Is this file being compiled as a MEX-file? */
#include "simulink.c"      /* MEX-file interface mechanism */
#else
#include "cg_sfun.h"       /* Code generation registration function */
#endif


