curdir = cd;
cd ('../../../dev/Rene/AnyBall/fotos-110610-2')
[fn,pn] = uigetfile('*.png');
fn = fullfile(pn,fn);
A = imread(fn);
cd(curdir)

compass_data = load('-ASCII',[fn(1:end-3) 'cps']);

clc
close all;
mex adaptivepolygonmask.c
mex staticmask.c
mex YUVmask.c
mex findball3D.c
mex findlinepoints_and_obstacles.c
mex labellerconvhull_invgreen.c
mex ballsizefilter.c
mex findpose.c
mex compasscheck.c
mex localisationaid.c
mex getvisiontime.c
mex ball_global2local.c

nn = 8;
k = nn*0;
for i=1:length(nn)
    n = nn(i);
    par_findpose = [200 .2];
    tic;sim('testballfilter');
    k(i)=toc;
end

%get mc
fid = fopen('mc.dat','rb');
mc = fread(fid,9,'double');
fclose(fid);

%plot stuff
figure('units','normalized','position',[.01 .05 .98 .86],'name',fn)
ax=axes('units','normalized','position',[0 .5 .2 .45]);imshow(ycbcr2rgb(A));title('RGB');hold on
plot(mc(2),mc(1),'*b',mc(8),mc(7),'*r')

BB = Ym(:,:,end);
BB(:,:,2) = Um(:,:,end);
BB(:,:,3) = Vm(:,:,end);
ax(2)=axes('units','normalized','position',[.2 .5 .2 .45]);imshow(BB);title('YUV + mask')
ax(3)=axes('units','normalized','position',[.4 .5 .2 .45]);imshow(blobs1(:,:,end)*255);title('color segmentation')
ax(4)=axes('units','normalized','position',[.6 .5 .2 .45]);imshow(blobs2(:,:,end)*255);title('distance dependent convolution')
ax(5)=axes('units','normalized','position',[.8 .5 .2 .45]);imshow(obstaclepoints(:,:,end)*100);title('obstacle info')
axes('units','normalized','position',[.3 .04 .4 .4])
for i=1:size(ballsconf,2)
    if ballsconf(end,i)
        plot(balls(end,i*3-2),balls(end,i*3-1),'mo')
        hold on
    end
end
if ballconf(end)
    plot(ball(end,1),ball(end,2),'ro')
end
plot(pose(end,1),pose(end,2),'b*')
for i=1:size(obstacles,2)/3
    plot(obstacles(end,3*i-2),obstacles(end,3*i-1),'k*')
end
plot(linepoints(:,1,end)*cos(pose(end,3)-mc(9))-linepoints(:,2,end)*sin(pose(end,3)-mc(9))+pose(end,1),...
    linepoints(:,1,end)*sin(pose(end,3)-mc(9))+linepoints(:,2,end)*cos(pose(end,3)-mc(9))+pose(end,2),...
     '.y')
axis image
axis([-6 6 -8 8])
linkaxes(ax,'xy')